Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.object
Class UpdatableSqlQuery<T>

    java.lang.Object
      org.springframework.jdbc.object.RdbmsOperation
          org.springframework.jdbc.object.SqlOperation
              org.springframework.jdbc.object.SqlQuery<T>
                  org.springframework.jdbc.object.UpdatableSqlQuery<T>

All Implemented Interfaces:
  InitializingBean

    public abstract class UpdatableSqlQuery<T>

extends SqlQuery<T>

Reusable RDBMS query in which concrete subclasses must implement the abstract updateRow(ResultSet, int, context) method to update each row of the JDBC ResultSet and optionally map contents into an object.

Subclasses can be constructed providing SQL, parameter types and a DataSource. SQL will often vary between subclasses.

Author:
  Thomas Risberg
See Also:
  `SqlQuery`

Nested Class Summary
`protected class` | `UpdatableSqlQuery.RowMapperImpl` Implementation of RowMapper that calls the enclosing class's `updateRow()` method for each row.

Field Summary

Fields inherited from class org.springframework.jdbc.object.RdbmsOperation
`logger`

Constructor Summary
`UpdatableSqlQuery()` Constructor to allow use as a JavaBean
`UpdatableSqlQuery(DataSource ds, String sql)` Convenient constructor with DataSource and SQL string.

Method Summary
`protected RowMapper<T>` | `newRowMapper(Object[] parameters, Map context)` Implementation of the superclass template method.
`protected abstract T` | `updateRow(ResultSet rs, int rowNum, Map context)` Subclasses must implement this method to update each row of the ResultSet and optionally create object of the result type.

Methods inherited from class org.springframework.jdbc.object.SqlQuery
`execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, executeByNamedParam, executeByNamedParam, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObjectByNamedParam, findObjectByNamedParam, getRowsExpected, setRowsExpected`

Methods inherited from class org.springframework.jdbc.object.SqlOperation
`compileInternal, getParsedSql, newPreparedStatementCreator, newPreparedStatementCreator, newPreparedStatementSetter, onCompileInternal`

Methods inherited from class org.springframework.jdbc.object.RdbmsOperation
`afterPropertiesSet, allowsUnusedParameters, checkCompiled, compile, declareParameter, getDeclaredParameters, getGeneratedKeysColumnNames, getJdbcTemplate, getResultSetType, getSql, isCompiled, isReturnGeneratedKeys, isUpdatableResults, setDataSource, setFetchSize, setGeneratedKeysColumnNames, setJdbcTemplate, setMaxRows, setParameters, setQueryTimeout, setResultSetType, setReturnGeneratedKeys, setSql, setTypes, setUpdatableResults, supportsLobParameters, validateNamedParameters, validateParameters`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### UpdatableSqlQuery

    public UpdatableSqlQuery()

  Constructor to allow use as a JavaBean

### UpdatableSqlQuery

    public UpdatableSqlQuery(DataSource ds,
                             String sql)

  Convenient constructor with DataSource and SQL string.

  Parameters:
    `ds` - DataSource to use to get connections
    `sql` - SQL to run

Method Detail

### newRowMapper

    protected RowMapper<T> newRowMapper(Object[] parameters,
                                        Map context)

  Implementation of the superclass template method. This invokes the subclass's implementation of the `updateRow()` method.

  Specified by:
    `newRowMapper` in class `SqlQuery<T>`
  Parameters:
    `parameters` - the parameters to the `execute()` method, in case subclass is interested; may be `null` if there were no parameters.
    `context` - contextual information passed to the `mapRow` callback method. The JDBC operation itself doesn't rely on this parameter, but it can be useful for creating the objects of the result list.
  See Also:
    `SqlQuery.execute(java.lang.Object[], java.util.Map)`

### updateRow

    protected abstract T updateRow(ResultSet rs,
                                   int rowNum,
                                   Map context)
                            throws SQLException

  Subclasses must implement this method to update each row of the ResultSet and optionally create object of the result type.

  Parameters:
    `rs` - ResultSet we're working through
    `rowNum` - row number (from 0) we're up to
    `context` - passed to the execute() method. It can be `null` if no contextual information is need. If you need to pass in data for each row, you can pass in a HashMap with the primary key of the row being the key for the HashMap. That way it is easy to locate the updates for each row
  Returns:
    an object of the result type
  Throws:
    `SQLException` - if there's an error updateing data. Subclasses can simply not catch SQLExceptions, relying on the framework to clean up.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD